#!/usr/bin/env python
# -*- coding:utf-8 -*-

# http://www.xin-yuan.com/cityzen/jiangtan/AHAN/ahan.htm
# http://www.dhammarain.org.tw/canon/pali-tipitaka-f1/index-pali.htm
# http://www.therawikipedia.org/wiki/%E5%A2%9E%E6%94%AF%E9%83%A8
# http://yifertw.blogspot.tw/2008/04/9-2008421.html
PaliTextTitle = {
'Tipiṭaka (Mūla)': '巴利三藏',
'Vinayapiṭaka': '律藏',
  'Pārājikapāḷi': '波羅夷品',
#   'Verañjakaṇḍaṃ': '',
    'Pārājikakaṇḍaṃ': '波羅夷 (他勝,斷頭)章',
    'Saṅghādisesakaṇḍaṃ': '僧殘 (僧伽胝施沙)章',
    'Aniyatakaṇḍaṃ': '不定章',
    'Nissaggiyakaṇḍaṃ': '捨墮 (尼薩耆波逸提)章',
  'Pācittiyapāḷi': '波逸提品',
    'Pācittiyakaṇḍaṃ': '波逸提 (單墮)章',
    'Pāṭidesanīyakaṇḍaṃ': '悔過 (波胝提舍尼)章',
    'Sekhiyakaṇḍaṃ': '眾學章',
    'Adhikaraṇasamathā': '滅諍',
    'bhikkhunīvibhaṅgo': '比丘尼分別',
  'Mahāvaggapāḷi': '大品',
    'Mahākhandhako': '大篇 (大犍度)',
    'Uposathakkhandhako': '伍波薩他篇 (布薩犍度)',
    'Vassūpanāyikakkhandhako': '入雨安居篇 (入雨安居犍度)',
    'Pavāraṇākkhandhako': '自恣篇 (自恣犍度)',
    'Cammakkhandhako': '皮革篇 (皮革犍度)',
    'Bhesajjakkhandhako': '藥篇 (藥犍度)',
    'Kathinakkhandhako': '咖提那篇 (迦絺那衣犍度)',
    'Cīvarakkhandhako': '衣篇 (衣犍度)',
    'Campeyyakkhandhako': '瞻巴篇 (瞻波犍度)',
    'Kosambakakkhandhako': '高賞比篇 (拘晱彌犍度)',
  'Cūḷavaggapāḷi': '小品',
    'Kammakkhandhakaṃ': '甘馬篇 (羯摩犍度)',
    'Pārivāsikakkhandhakaṃ': '別住篇 (別住犍度)',
    'Samuccayakkhandhakaṃ': '集篇 (集犍度)',
    'Samathakkhandhakaṃ': '止篇 (滅諍犍度)',
    'Khuddakavatthukkhandhakaṃ': '小事篇 (小犍度)',
    'Senāsanakkhandhakaṃ': '坐卧處篇 (臥坐具犍度)',
    'Saṅghabhedakakkhandhakaṃ': '破僧篇 (破僧犍度)',
    'Vattakkhandhakaṃ': '行儀篇 (儀法犍度)',
    'Pātimokkhaṭṭhapanakkhandhakaṃ': '遮誦戒篇 (遮說戒犍度)',
    'Bhikkhunikkhandhakaṃ': '比庫尼篇 (比丘尼犍度)',
    'Pañcasatikakkhandhakaṃ': '五百篇 (五百結集犍度)',
    'Sattasatikakkhandhakaṃ': '七百篇 (七百結集犍度)',
  'Parivārapāḷi': '附隨',
#   'Soḷasamahāvāro': '',
    'Samuṭṭhānasīsasaṅkhepo': '等起攝頌 (等起)',
    'Antarapeyyālaṃ': '無間省略',
    'Khandhakapucchāvāro': '問犍度章',
    'Ekuttarikanayo': '增一法',
    'Uposathādipucchāvissajjanā': '伍波薩他初解答章 (布薩初解答以及制戒義利論)',
    'Gāthāsaṅgaṇikaṃ': '伽陀集',
    'Adhikaraṇabhedo': '諍事分解',
    'Aparagāthāsaṅgaṇikaṃ': '別伽陀集',
    'Codanākaṇḍaṃ': '呵責品',
    'Cūḷasaṅgāmo': '小諍',
    'Mahāsaṅgāmo': '大諍',
    'Kathinabhedo': '咖提那衣分解 (迦絺那衣分解)',
    'Upālipañcakaṃ': '伍巴離五法 (優婆離五法)',
    'Atthāpattisamuṭṭhānaṃ': '等起',
    'Dutiyagāthāsaṅgaṇikaṃ': '第二伽陀集',
    'Sedamocanagāthā': '發汗偈',
    'Pañcavaggo': '五品',
'Suttapiṭaka': '經藏',
  'Dīghanikāya': '長部',
  'Dīgha nikāya': '長部',
    'Sīlakkhandhavaggapāḷi':'戒蘊品',
      'Brahmajālasuttaṃ': '梵網經',
      'Sāmaññaphalasuttaṃ': '沙門果經',
      'Ambaṭṭhasuttaṃ': '阿摩晝經',
      'Soṇadaṇḍasuttaṃ': '種德經',
      'Kūṭadantasuttaṃ': '究羅檀頭經',
      'Mahālisuttaṃ': '摩訶梨經',
      'Jāliyasuttaṃ': '闍利經',
      'Mahāsīhanādasuttaṃ': '迦葉獅子吼經',
      'Poṭṭhapādasuttaṃ': '布吒婆樓經',
      'Subhasuttaṃ': '須婆經',
      'Kevaṭṭasuttaṃ': '堅固經',
      'Lohiccasuttaṃ': '露遮經',
      'Tevijjasuttaṃ': '三明經',
    'Mahāvaggapāḷi':'大品',
      'Mahāpadānasuttaṃ': '大本經',
      'Mahānidānasuttaṃ': '大緣經',
      'Mahāparinibbānasuttaṃ': '大般涅槃經',
      'Mahāsudassanasuttaṃ': '大善見王經',
      'Janavasabhasuttaṃ': '闍尼沙經',
      'Mahāgovindasuttaṃ': '大典尊經',
      'Mahāsamayasuttaṃ': '大會經',
      'Sakkapañhasuttaṃ': '帝釋所問經',
      'Mahāsatipaṭṭhānasuttaṃ': '大念處經',
      'Pāyāsisuttaṃ': '弊宿經',
    'Pāthikavaggapāḷi':'波梨品',
      'Pāthikasuttaṃ': '波梨經',
      'Udumbarikasuttaṃ': '優曇婆邏獅子吼經',
      'Cakkavattisuttaṃ': '轉輪聖王獅子吼經',
      'Aggaññasuttaṃ': '起世因本經',
      'Sampasādanīyasuttaṃ': '自歡喜經',
      'Pāsādikasuttaṃ': '清淨經',
      'Lakkhaṇasuttaṃ': '三十二相經',
      'Siṅgālasuttaṃ': '教授屍迦羅越經',
      'Āṭānāṭiyasuttaṃ': '阿吒曩胝經',
      'Saṅgītisuttaṃ': '等誦經',
      'Dasuttarasuttaṃ': '十上經',
  'Majjhimanikāya': '中部',
    'Mūlapaṇṇāsapāḷi': '根本五十經編',
      'Mūlapariyāyavaggo': '根本法門品',
      'Sīhanādavaggo': '師子吼品',
      'Opammavaggo': '譬喻品',
      'Mahāyamakavaggo': '大雙品',
      'Cūḷayamakavaggo': '小雙品',
    'Majjhimapaṇṇāsapāḷi': '中分五十經編',
      'Gahapativaggo': '居士品',
      'Bhikkhuvaggo': '比丘品',
      'Paribbājakavaggo': '遊行者品',
      'Rājavaggo': '王品',
      'Brāhmaṇavaggo': '婆羅門品',
    'Uparipaṇṇāsapāḷi': '後分五十經編',
      'Devadahavaggo': '天臂品',
      'Anupadavaggo': '緊隨品',
      'Suññatavaggo': '空品',
      'Vibhaṅgavaggo': '分別品',
      'Saḷāyatanavaggo': '六處品',
  'Saṃyuttanikāya': '相應部',
    'Sagāthāvaggapāḷi': '有偈篇',
      'Devatāsaṃyuttaṃ': '諸天相應',
      'Devaputtasaṃyuttaṃ': '天子相應',
      'Kosalasaṃyuttaṃ': '憍薩羅相應',
      'Mārasaṃyuttaṃ': '魔羅相應',
      'Bhikkhunīsaṃyuttaṃ': '比丘尼相應',
      'Brahmasaṃyuttaṃ': '梵天相應',
      'Brāhmaṇasaṃyuttaṃ': '婆羅門相應',
      'Vaṅgīsasaṃyuttaṃ': '婆耆沙長老相應',
      'Vanasaṃyuttaṃ': '森林相應',
      'Yakkhasaṃyuttaṃ': '夜叉相應',
      'Sakkasaṃyuttaṃ': '帝釋天帝相應',
    'Nidānavaggapāḷi': '因緣篇',
      'Nidānasaṃyuttaṃ': '因緣相應',
      'Abhisamayasaṃyuttaṃ': '現觀相應',
      'Dhātusaṃyuttaṃ': '界相應',
      'Anamataggasaṃyuttaṃ': '無始相應',
      'Kassapasaṃyuttaṃ': '迦葉相應',
      'Lābhasakkārasaṃyuttaṃ': '利得與供養相應',
      'Rāhulasaṃyuttaṃ': '羅睺羅相應',
      'Lakkhaṇasaṃyuttaṃ': '勒叉那相應',
      'Opammasaṃyuttaṃ': '譬喻相應',
      'Bhikkhusaṃyuttaṃ': '比丘相應',
    'Khandhavaggapāḷi': '蘊篇',
      'Khandhasaṃyuttaṃ': '蘊相應',
      'Rādhasaṃyuttaṃ': '羅陀相應',
      'Diṭṭhisaṃyuttaṃ': '見相應',
      'Okkantasaṃyuttaṃ': '入相應',
      'Uppādasaṃyuttaṃ': '生相應',
      'Kilesasaṃyuttaṃ': '煩惱相應',
      'Sāriputtasaṃyuttaṃ': '舍利弗相應',
      'Nāgasaṃyuttaṃ': '龍相應',
      'Supaṇṇasaṃyuttaṃ': '金翅鳥相應',
      'Gandhabbakāyasaṃyuttaṃ': '乾闥婆相應',
      'Valāhakasaṃyuttaṃ': '雲相應',
      'Vacchagottasaṃyuttaṃ': '婆磋種相應',
      'Jhānasaṃyuttaṃ': '禪定相應',
    'Saḷāyatanavaggapāḷi': '六處篇',
      'Saḷāyatanasaṃyuttaṃ': '六處相應',
      'Vedanāsaṃyuttaṃ': '受相應',
      'Mātugāmasaṃyuttaṃ': '女人相應',
      'Jambukhādakasaṃyuttaṃ': '閻浮車相應',
      'Sāmaṇḍakasaṃyuttaṃ': '沙門出家相應',
      'Moggallānasaṃyuttaṃ': '目犍連相應',
      'Cittasaṃyuttaṃ': '質多相應',
      'Gāmaṇisaṃyuttaṃ': '聚落主相應',
      'Asaṅkhatasaṃyuttaṃ': '無為相應',
      'Abyākatasaṃyuttaṃ': '無記相應',
#   'Mahāvaggapāḷi': '大篇',
      'Maggasaṃyuttaṃ': '道相應',
      'Bojjhaṅgasaṃyuttaṃ': '覺支相應',
      'Satipaṭṭhānasaṃyuttaṃ': '念處相應',
      'Indriyasaṃyuttaṃ': '根相應',
      'Sammappadhānasaṃyuttaṃ': '正勤相應',
      'Balasaṃyuttaṃ': '力相應',
      'Iddhipādasaṃyuttaṃ': '神足相應',
      'Anuruddhasaṃyuttaṃ': '阿那律相應',
#     'Jhānasaṃyuttaṃ': '靜慮相應',
      'Ānāpānasaṃyuttaṃ': '入出息相應',
      'Sotāpattisaṃyuttaṃ': '入流 (須陀洹)相應',
      'Saccasaṃyuttaṃ': '諦相應',
  'Aṅguttaranikāya': '增支部',
    'Ekakanipātapāḷi': '一集',
      'Rūpādivaggo': '色等品',
      'Nīvaraṇappahānavaggo': '斷蓋品',
      'Akammaniyavaggo': '無堪忍品',
      'Adantavaggo': '無調品',
      'Paṇihitaacchavaggo': '向與隱覆品',
      'Accharāsaṅghātavaggo': '彈指品',
      'Vīriyārambhādivaggo': '發精進等品',
      'Kalyāṇamittādivaggo': '善友等品',
      'Pamādādivaggo': '放逸等品',
#     'Dutiyapamādādivaggo': '',
      'Adhammavaggo': '非法等品',
      'Anāpattivaggo': '無范等品',
      'Ekapuggalavaggo': '一人品',
      'Etadaggavaggo': '是第一品',
      'Aṭṭhānapāḷi': '無有是處品',
      'Ekadhammapāḷi': '一法品',
      'Pasādakaradhammavaggo': '種子品',
      'Aparaaccharāsaṅghātavaggo': '末伽梨品',
      'Kāyagatāsativaggo': '不放逸品',
      'Amatavaggo': '靜慮品',
    'Dukanipātapāḷi': '二集',
      'Kammakaraṇavaggo': '科刑罰品',
      'Adhikaraṇavaggo': '靜論品',
      'Bālavaggo': '愚人品',
      'Samacittavaggo': '等心品',
      'Parisavaggo': '會眾品',
      'Puggalavaggo': '人品',
      'Sukhavaggo': '樂品',
      'Sanimittavaggo': '有品',
      'Dhammavaggo': '法品',
#     'Bālavaggo': '愚者品',
      'Āsāduppajahavaggo': '希望品',
      'Āyācanavaggo': '希求品',
      'Dānavaggo': '施品',
      'Santhāravaggo': '覆護品',
      'Samāpattivaggo': '入定品',
      'Kodhapeyyālaṃ': '忿品',
      'Akusalapeyyālaṃ': '(律廣說)品',
#     'Vinayapeyyālaṃ': '',
#     'Rāgapeyyālaṃ': '',
    'Tikanipātapāḷi': '三集',
#     'Bālavaggo': '愚人品',
      'Rathakāravaggo': '車匠品',
#     'Puggalavaggo': '補特羅品',
      'Devadūtavaggo': '天使品',
#     'Cūḷavaggo': '小品',
#     'Brāhmaṇavaggo': '婆羅門品',
#     'Mahāvaggo': '大品',
      'Ānandavaggo': '阿難品',
      'Samaṇavaggo': '沙門品',
      'Loṇakapallavaggo': '掬鹽品',
      'Sambodhavaggo': '等覺品',
      'Āpāyikavaggo': '惡趣品',
      'Kusināravaggo': '古西那拉品',
      'Yodhājīvavaggo': '戰士品',
      'Maṅgalavaggo': '吉祥品',
      'Acelakavaggo': '裸形品',
#     'Kammapathapeyyālaṃ': '',
#     'Rāgapeyyālaṃ': '',
    'Catukkanipātapāḷi': '四集',
    'Pañcakanipātapāḷi': '五集',
    'Chakkanipātapāḷi': '六集',
    'Sattakanipātapāḷi': '七集',
    'Aṭṭhakādinipātapāḷi': '八集',
    'Navakanipātapāḷi': '九集',
    'Dasakanipātapāḷi': '十集',
    'Ekādasakanipātapāḷi': '十一集',
      'Nissayavaggo': '依止品',
      'Anussativaggo': '憶念品',
      'Sāmaññavaggo': '沙門品',
      'Rāgapeyyālaṃ': '貪品',
  'Khuddakanikāya': '小部',
    'Khuddakapāṭhapāḷi': '小誦',
      'Saraṇattayaṃ': '三皈依',
      'Dasasikkhāpadaṃ': '十戒',
      'Dvattiṃsākāro': '三十二身分',
      'Kumārapañhā': '問童子',
      'Maṅgalasuttaṃ': '吉祥經',
      'Ratanasuttaṃ': '寶經',
      'Tirokuṭṭasuttaṃ': '戶外經',
      'Nidhikaṇḍasuttaṃ': '伏藏經',
      'Mettasuttaṃ': '慈經',
    'Dhammapadapāḷi': '法句(經)',
      'Yamakavaggo': '雙品',
      'Appamādavaggo': '不放逸品',
      'Cittavaggo': '心品',
      'Pupphavaggo': '華(花)品',
#     'Bālavaggo': '愚品',
      'Paṇḍitavaggo': '智者品',
      'Arahantavaggo': '阿羅漢品',
      'Sahassavaggo': '千品',
      'Pāpavaggo': '惡品',
      'Daṇḍavaggo': '刀杖品',
      'Jarāvaggo': '老品',
      'Attavaggo': '自己品',
      'Lokavaggo': '世品',
      'Buddhavaggo': '佛陀品',
#     'Sukhavaggo': '樂品',
      'Piyavaggo': '喜愛品',
      'Kodhavaggo': '忿怒品',
      'Malavaggo': '垢穢品',
      'Dhammaṭṭhavaggo': '法住品',
      'Maggavaggo': '道品',
      'Pakiṇṇakavaggo': '雜品',
      'Nirayavaggo': '地獄品',
      'Nāgavaggo': '象品',
      'Taṇhāvaggo': '愛欲品',
#     'Bhikkhuvaggo': '比丘品',
#     'Brāhmaṇavaggo': '婆羅門品',
    'Udānapāḷi': '自說',
    'Itivuttakapāḷi': '如是語',
    'Suttanipātapāḷi': '經集',
      'Uragavaggo': '蛇品',
      'Cūḷavaggo': '小品',
      'Mahāvaggo': '大品',
      'Aṭṭhakavaggo': '八頌經品',
      'Pārāyanavaggo': '彼岸道品',
    'Vimānavatthupāḷi': '天宮事',
    'Petavatthupāḷi': '餓鬼事',
    'Theragāthāpāḷi': '長老偈',
    'Therīgāthāpāḷi': '長老尼偈',
    'Apadānapāḷi': '譬喻',
    'Buddhavaṃsapāḷi': '佛種姓 (諸佛史)',
    'Cariyāpiṭakapāḷi': '所行藏',
    'Jātakapāḷi': '本生(經)',
    'Mahāniddesapāḷi': '大義釋',
    'Cūḷaniddesapāḷi': '小義釋',
    'Paṭisambhidāmaggapāḷi': '無礙解道',
    'Nettippakaraṇapāḷi': '導論',
    'Milindapañhapāḷi': '彌林達問經 (彌林達王問經,那先比丘經)',
    'Peṭakopadesapāḷi': '藏釋 (三藏知津)',
'Abhidhammapiṭaka': '論藏 (阿毘達摩)',
  'Dhammasaṅgaṇīpāḷi': '法集論',
  'Vibhaṅgapāḷi': '分別論',
  'Dhātukathāpāḷi': '界說論',
  'Puggalapaññattipāḷi': '人施設論',
  'Kathāvatthupāḷi': '論事',
  'Yamakapāḷi': '雙對論',
  'Paṭṭhānapāḷi': '發趣論',
'Aṭṭhakathā': '義疏(註釋書)',
'Tīkā': '復註(義疏再解釋)',
  'Abhidhammatthasaṅgaho': '攝阿毘達摩義論',
    'Cittaparicchedo': '第一攝心分別品',
    'Cetasikaparicchedo': '第二攝心所分別品',
    'Pakiṇṇakaparicchedo': '第三攝雜分別品',
    'Vīthiparicchedo': '第四攝路分別品',
    'Vīthimuttaparicchedo': '第五攝離路分別品',
    'Rūpaparicchedo': '第六攝色分別品',
    'Samuccayaparicchedo': '第七攝集分別品',
    'Paccayaparicchedo': '第八攝緣分別品',
    'Kammaṭṭhānaparicchedo': '第九攝業處分別品',
'Anya': '藏外文獻',
  'Visuddhimagga': '清淨道論',
      'Sīlaniddeso': '說戒品',
      'Dhutaṅganiddeso': '說頭陀支品',
      'Kammaṭṭhānaggahaṇaniddeso': '說取業處品',
      'Pathavīkasiṇaniddeso': '說地遍品',
      'Sesakasiṇaniddeso': '說餘遍品',
      'Asubhakammaṭṭhānaniddeso': '說不淨業處品',
      'Chaanussatiniddeso': '說六隨念品',
      'Anussatikammaṭṭhānaniddeso': '說隨念業處品',
      'Brahmavihāraniddeso': '說梵住品',
      'Āruppaniddeso': '說無色品',
      'Samādhiniddeso': '說定品',
      'Iddhividhaniddeso': '說神變品',
      'Abhiññāniddeso': '說神通品',
      'Khandhaniddeso': '說蘊品',
      'Āyatanadhātuniddeso': '說處界品',
      'Indriyasaccaniddeso': '說根諦品',
      'Paññābhūminiddeso': '說慧地品',
      'Diṭṭhivisuddhiniddeso': '說見清淨品',
      'Kaṅkhāvitaraṇavisuddhiniddeso': '說度疑清淨品',
      'Maggāmaggañāṇadassanavisuddhiniddeso': '說道非道智見清淨品',
      'Paṭipadāñāṇadassanavisuddhiniddeso': '說行道智見清淨品',
      'Ñāṇadassanavisuddhiniddeso': '說智見清淨品',
      'Paññābhāvanānisaṃsaniddeso': '說修慧的功德品',
    'Visuddhimagga-mahāṭīkā': '清淨道論大疏',
    'Visuddhimagga nidānakathā': '清淨道論因緣論',
    'Saṅgāyana-puccha vissajjanā': '結集問答',
      'Dīghanikāya (pu-vi)': '長部結集問答',
      'Majjhimanikāya (pu-vi)': '中部結集問答',
      'Saṃyuttanikāya (pu-vi)': '相應部結集問答',
      'Aṅguttaranikāya (pu-vi)': '增支部結集問答',
      'Vinayapiṭaka (pu-vi)': '律藏結集問答',
      'Abhidhammapiṭaka (pu-vi)': '阿毘達摩藏之結集問答',
      'Aṭṭhakathā (pu-vi)': '注釋之結集問答',
' ': ' '
}

